if(!dojo._hasResource["com.ibm.customize.ChangeStylePaletteContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.ChangeStylePaletteContainer"] = true;
// This is Change Style
dojo.provide("com.ibm.customize.ChangeStylePaletteContainer");

dojo.require("com.ibm.customize.LotusPaletteContainer");
dojo.requireLocalization("com.ibm.bundles", "Theme");

dojo.declare("com.ibm.customize.ChangeStylePaletteContainer",
	[com.ibm.customize.LotusPaletteContainer],
	{
		numRows: 3,			// the number of rows of results to be displayed
		baseCssPath: "",
		
		constructor: function() {
			this.label = this.nlsBundle["change_style_browseStyles"];
			this.tabLabel = this.nlsBundle["change_style_launchLabel"];
			this.themeBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		},
		
		postCreate: function(){
			this.inherited("postCreate",arguments);
			
			// change the size of the item results by adding a css class
			dojo.addClass(this.domNode,"lotusLargeWidgets");
			
			// when the apply function from the Customize Controller API is executed, change the visually selected item
			this.connect(this, "apply", "changeSelection");
		},
		
		setupUICallback: function(sources){
			dojo.forEach(sources, dojo.hitch(this, function(source){ 
				source.hub.fetch({
					onComplete:dojo.hitch(this, function(items){
						dojo.forEach(items, dojo.hitch(this, function(item){
							if(dojo.query("[title~="+item.id[0]+"]").length == 0)
								this._loadCss(this.baseCssPath + item.id[0] + ".css",item.id[0],true,true);
						}));
					})
				});
			}));
			this.inherited(arguments);
		},
		
		changeSelection: function(/*object*/args){
			// summary: called when apply is called
			// args: contains args.id which is the newly selected item
			this.changeSelected(args.id);
		},
		newCell: function(/*Object*/source,/*DataItem*/item){
			// summary:  override this function to fill innerCell with information about the given datastore item
			// source: a datastore
			// item: an item in source
			var node = this.inherited(arguments),
				widget = dijit.byNode(node),
				editStyleFn = dojo.getObject("ibmCfg.themeConfig.editStyle"); // check if its defined
			if(editStyleFn && widget && widget.textBlock){
				var anchor = dojo.create("a", {
					href: "javascript:void(0);",
					className: "editStyleLink",
					innerHTML: this.themeBundle.edit_title
				}, widget.textBlock);
				widget.connect(anchor, "onclick", function(){
					ibmCfg.themeConfig.editStyle({	// use the reference here in case it changes
						source: source, 
						item: item, 
						node: anchor, 
						apply: widget.apply	// this is the function to call when selecting a style
					});
				});
			}
			return node;
		}
});

}
