if(!dojo._hasResource["com.ibm.mm.builder.Personalize"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.Personalize"] = true;
/**
 * @author Michael Duan (duanyg@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.Personalize");
dojo.require("com.ibm.mashups.builder.Personalize");
dojo.require("com.ibm.mm.builder.utils.navigationUtil");

dojo.declare("com.ibm.mm.builder.PersonalizeImpl", com.ibm.mashups.builder.Personalize, {
    constructor: function(){
    },
    
    getWidgetAccessor: function(widgetId){
        return com.ibm.mashups.enabler.model.state.AccessorFactory.getWidgetAccessor(
			com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel(), widgetId);
    },
    
    setPersonalizeSize: function(widgetId, size){
        this.getWidgetAccessor(widgetId).setSize(size.w, size.h);
        var location = {};
        location.x = parseInt(size.l,10);
        location.y = parseInt(size.t,10);
        this.getWidgetAccessor(widgetId).setWidgetState("l", location);
        
        this.commit();
    },
    
    getPersonalizeSize: function(widgetId){
        var widgetSize = this.getWidgetAccessor(widgetId).getSize();
        var location = this.getWidgetAccessor(widgetId).getWidgetState("l");
        
        if (widgetSize === null) {
			return null;
		}
        
        var size = {};
        size.w = widgetSize.w;
        size.h = widgetSize.h;
        if (location === null) {
            size.l = 0;
            size.t = 0;
        }
        else {
            size.l = location.x;
            size.t = location.y;
        }
        
        return size;
    },
    
    setPersonalizeWidgetState: function(widgetId, state){
        this.getWidgetAccessor(widgetId).setWindowState(state);
        
        this.commit();
    },
    
    getPersonalizeWidgetState: function(widgetId){
        return this.getWidgetAccessor(widgetId).getWindowState();
    },
    
    commit: function(){
        com.ibm.mm.builder.utils.navigationUtil.getNavigationStateModel().commit().start();
    },
    
    isWidgetInLayout: function(widgetId, layoutWidgetId){
        return com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId, layoutWidgetId);
    },
    
    getWidgetSkinNode: function(widgetId){
//        return dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
		return dojo.query("[title~="+widgetId+"]")[0];
    },
    
    _getWidgetBodyPadTop: function(widgetId){
        var widgetBodyPadTop = com.ibm.mm.builder.utils.htmlUtil.getCurrentStyle(dojo.byId(widgetId +
        com.ibm.mm.builder.constant.widgetBody), "paddingTop");
        widgetBodyPadTop = widgetBodyPadTop ? parseInt(widgetBodyPadTop,10) : 0;
        return widgetBodyPadTop;
    },
    
    getWidgetContentNode: function(widgetId){
//        return dojo.byId(widgetId + com.ibm.mm.builder.constant.widgetContent);
		return dojo.byId(widgetId).parentNode;
    },
    
    resetWidgetSkin: function(widgetId, size){
        // resize the skin of widget.	  
        dojo.contentBox(this.getWidgetSkinNode(widgetId), {
            l: parseInt(size.l,10),
            t: parseInt(size.t,10),
            w: parseInt(size.w,10),
            h: parseInt(size.h,10)
        });
    },
    
    publicResizeEvent: function(widgetId){
        // publish the resize event to enabler
        var widgetContentBox = dojo.contentBox(this.getWidgetContentNode(widgetId));
        var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
        var payload = {
            "newWidth": widgetContentBox.w,
            "newHeight": widgetContentBox.h
        };
        eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + widgetId, payload);
    },
    
    resetWidgetContent: function(widgetId, size){
        // resize the content of widget
        var widgetContentNode = this.getWidgetContentNode(widgetId);
        var widgetBodyPadTop = this._getWidgetBodyPadTop(widgetId);
        dojo.marginBox(widgetContentNode, {
            l: 0,
            t: 0,
            w: parseInt(size.w,10),
            h: parseInt(size.h,10) - widgetBodyPadTop
        });
    }
});

com.ibm.mashups.builder.Personalize = new com.ibm.mm.builder.PersonalizeImpl();

}
