if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget"] = true;
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerActionBar");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.PageCreationWidget");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil");

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget", [dijit._Widget, dijit._Templated, com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin], {
	templatePath : dojo.moduleUrl("com.ibm.mm.builder", "iwidget/spacemanager/widget/templates/SpaceManagerWidget.html"),
	widgetsInTemplate : true,
	
	constructor : function(options) {
		this._constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
		this._bundle = com.ibm.mm.builder.coreWidgetsStrings;
		this._utils = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil;
		this._eventService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
		this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
		this._subscriptions = [];
	},
	
	postMixInProperties : function() {
		dojo.mixin(this, this._bundle);
	},
	
	postCreate : function() {
		this._setupSubComponents();
	},
	
	_setupSubComponent : function(nodeClassName, dijitClass, extraOptions) {
		var node = dojo.query("." + nodeClassName, this.domNode)[0];
		var option = dojo.mixin({}, extraOptions, {spaceManager : this.getSpaceManager()});
		return new dijitClass(option, node);
	},
	
	_setupSubComponents : function() {
		this._setupSubComponent("category_selector", com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceCategorySelector);
		
		this._setupSubComponent("recent_spaces_list", com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList, {
			_title : this._bundle.I_SPACE_MANAGER_RECENT_SPACES_TITLE,
			modelNames : this._constants.ModelName.RecentlyVisitedSpaces
		});
		
		this._setupSubComponent("space_list", com.ibm.mm.builder.iwidget.spacemanager.widget.DetailedSpacesList);
		
		this._subscriptions.push(dojo.subscribe(this._constants.Topic.Common.showMessage, this, this.showMessage));
		this._subscriptions.push(dojo.subscribe(this._constants.Topic.Common.hideMessage, this, this.hideMessage));
	},
	
	showMessage : function(message, type) {
		if(!this._messageControl){
			this._messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
			messageType: 'error'}, this._messageNode);
		}
		this._messageControl.attr({
			"message" : message,
			"messageType" : type || "error"
		});
		this._messageControl.show();
	},
	
	hideMessage : function() {
		if (this._messageControl) {
			this._messageControl.hide();
		}
	},
	
	onSpaceCreated : function(spaceId) {
		dojo.publish(this._constants.Topic.Space.refresh,[this._constants.Action.CREATE_SPACE, {spaceId: spaceId}]);
	},
	
	refresh : function() {
		dojo.publish(this._constants.Topic.Space.refresh);
		dojo.publish(this._constants.Topic.Space.refreshRecentSpaces);
	},
	
	uninitialized: function() {
        dojo.forEach(this._subscriptions, dojo.unsubscribe);
    }
});

}
