if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");

com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsConstants = {
	SEMANTIC_TYPES_ONLY: 0,
	PAYLOAD_TYPES_ONLY: 1,
	SEMANTIC_OR_PAYLOAD_TYPES: 2,
	SETTING_MATCHING_TYPE: "matchingType"
};

dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog", [dijit._Widget, dijit._Templated], {
	notificationDialog:null,
	
	widgetId: null,
	
	dialogWidgetId: "Mashup_Wiring_Settings_Dlg",
	
	templatePath: dojo.moduleUrl("com.ibm.mm.builder.iwidget.wiringscreen", "templates/wiringSettingsDialog.html"),
	
	constants: com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsConstants,
						
	constructor:function(){
	},
	
	onSettingsSaved: function ( /*Map*/settings ) {
	},
	
	postCreate:function(){
		this.initContent();
	},
	
	setOuterContext: function ( ctx ) {
		this.outerContext = ctx;
	},
	
	setMatchingType: function ( currentMatchingType ) {
		//Should be set by the code opening the dialog.
		switch ( currentMatchingType ) {
			case 0: this.matchingOption1.checked = true; break;
			case 1: this.matchingOption2.checked = true; break;
			case 2: this.matchingOption3.checked = true; break;
			default: this.matchingOption1.checked = true;
		}
	},
	
	initContent:function(){
		var cws = com.ibm.mm.builder.coreWidgetsStrings;
		
		this.matchingOptionsTitleDiv.innerHTML = cws.I_WIRING_MATCHING_MODE;

		this.matchingOption1Text.innerHTML = cws.I_WIRING_ALIAS_MATCH;
		this.matchingOption1.value = this.constants.SEMANTIC_TYPES_ONLY;
		
		this.matchingOption2Text.innerHTML = cws.I_WIRING_PAYLOAD_TYPE_MATCH;
		this.matchingOption2.value = this.constants.PAYLOAD_TYPES_ONLY;
		
		this.matchingOption3Text.innerHTML = cws.I_WIRING_PAYLOAD_TYPE_OR_ALIAS_MATCH;
		this.matchingOption3.value = this.constants.SEMANTIC_OR_PAYLOAD_TYPES;
		
		dojo.attr(this.buttonDivDone,"title",cws.I_WIRING_DONE);
		dojo.attr(this.buttonDivDone,"value",cws.I_WIRING_DONE);
		
		dojo.connect( this.buttonDivDone, "onclick", dojo.hitch( this, this.makeSelectionAndClose ) );
		
		var contentDiv = document.createElement("div");
		contentDiv.appendChild(this.wiringSettingsDiv);
		this.notificationDialog = dijit.byId(this.dialogWidgetId);
		if (!this.notificationDialog) {
			this.notificationDialog = new com.ibm.mm.builder.widget.CustomDialog({
				id: this.dialogWidgetId,
				title: cws.I_WIRING_SETTINGS_DIALOG_NAME,
				needUnderLay: true,
				roundCorner: false,
				modelDialog: true,
				hasRightBottomResizer: false
			
			}, contentDiv);
		}
	},
	
	destroy:function() {
		this.notificationDialog.destroy();
	},
	
	show:function(widgetId) {
		this.notificationDialog.show();
	},
	
	hide:function(){
		if(this.notificationDialog) {
			this.notificationDialog.hide();
		}
	},
	
	_buildSettingsMap: function () {
		var settings = {};
		settings[ this.constants.SETTING_MATCHING_TYPE ] = this._getMatchingType();
		return settings;
	},
	
	_getMatchingType: function () {
		var choice;
		
		if ( this.matchingOption1.checked ) {
			choice = parseInt( this.matchingOption1.value );
		} else if ( this.matchingOption2.checked ) {
			choice = parseInt( this.matchingOption2.value );
		} else if ( this.matchingOption3.checked ) {
			choice = parseInt( this.matchingOption3.value );
		}
		
		return choice;	
	},
	
	makeSelection: function () {
		var settings = this._buildSettingsMap();
		this.onSettingsSaved( settings );
	},
	
	makeSelectionAndClose: function () {
		this.makeSelection();
		this.hide();
	}
});

}
