if(!dojo._hasResource["com.ibm.mm.builder.utils.enablerUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.enablerUtil"] = true;
/**
 * @author Jove (zhongqj@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.enablerUtil");

/**
 *
 * @param {String} key
 * @return {String} if the key is never saved, null will be returned
 */
com.ibm.mm.builder.utils.enablerUtil.getPageMetaData = function(key, pageId) {
    var currentPage = null;
    if (typeof pageId != "undefined") {
        currentPage = com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId);
    }
    else {
        currentPage = com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
    }
    
    if (currentPage) {
        //		var layoutModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel().getLayoutModel(currentPage.getID());
        //		if(layoutModel) {
        //			var lmRoot = layoutModel.getRoot().start();
        //			if (lmRoot){
        //				return lmRoot.getMetaData(key);
        //			}
        //		}
        var pageContent = currentPage.getContent().start();
        return pageContent.getMetaData(key);
    }
    return null;
};

com.ibm.mm.builder.utils.enablerUtil.setPageMetaData = function(key, value, pageId) {
    var pageNode = pageId ? com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId) : com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
    if (pageNode) {
        var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
        //		var layoutModel = navModel.getLayoutModel(pageNode.getID());
        //		if (layoutModel) {
        //			var lmRoot = layoutModel.getRoot().start();
        //			if (lmRoot) {
        //				lmRoot.setMetaData(key, value);
        //				navModel.commit().start();
        //			}
        //		}
        var pageContent = pageNode.getContent().start();
        pageContent.setMetaData(key, value);
        navModel.commit().start();
    }
};

com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData = function(metadata, pageId) {
    var pageNode = pageId ? com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId) : com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
    if (pageNode) {
        var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
        var layoutModel = navModel.getLayoutModel(pageNode.getID());
        if (layoutModel) {
            var lmRoot = layoutModel.getRoot().start();
            if (lmRoot) {
                for (var key in metadata) {
                    if (Object.prototype.hasOwnProperty.call(metadata, key)) {
                        lmRoot.setMetaData(key, metadata[key]);
                    }
                }
                navModel.commit().start();
            }
        }
    }
};

com.ibm.mm.builder.utils.enablerUtil.removePageMetaData = function(keys, pageId) {
    var pageNode = pageId ? com.ibm.mm.builder.utils.pageUtil.getPageNode(pageId) : com.ibm.mm.builder.utils.pageUtil.getCurrentPageNode();
    if (pageNode) {
        var navModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
        var layoutModel = navModel.getLayoutModel(pageNode.getID());
        if (layoutModel) {
            var lmRoot = layoutModel.getRoot().start();
            if (lmRoot) {
                dojo.forEach(keys, function(key) {
                    if (key != "com.ibm.mashups.acl.role.USER" && key != "com.ibm.mashups.acl.role.EDITOR") {
                        lmRoot.removeMetaData(key);
                    }
                });
                navModel.commit().start();
            }
        }
    }
};

com.ibm.mm.builder.utils.enablerUtil.getUnescapedNodeTitle = function(node, locale) {
    if (!node) {
        return null;
    }
    // node locale when created -- will be en if locale = en_**/en
    var title = "";
    if (locale) {
        title = node.getTitle(locale);
    }
    if (!title) {
        title = com.ibm.mashups.enabler.context.Factory.getLocalizedContext().getTitle(node);
    }
    return title;
};

com.ibm.mm.builder.utils.enablerUtil.getNodeTitle = function(node, locale) {
    return com.ibm.mm.builder.utils.htmlUtil.escapeString(com.ibm.mm.builder.utils.enablerUtil.getUnescapedNodeTitle(node, locale));
};

com.ibm.mm.builder.utils.enablerUtil.getNodeDescription = function(node, locale) {
    if (!node) {
        return null;
    }
    var desc = null;
    try {
        if (locale) {
            desc = node.getDescription(locale);
        }
        if (!desc) {
            desc = com.ibm.mashups.enabler.context.Factory.getLocalizedContext().getDescription(node);
        }
		if (!desc || desc === "null"){
			desc = "";
		}
    } 
    catch (ex) {
        console.log("failed to load the description of the node");
    }
    return desc;
};

}
