if(!dojo._hasResource["com.ibm.mm.builder.utils.toolboxUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.toolboxUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.toolboxUtil");
/**
 * find widget definition metadata in categories;
 * it will be replaced when enabler provide handy API.
 *
 * //TODO have to cache the metadata for dnd, it is too late to create avatar until retrieving data from server by enabler
 * @param {String} widgetDefId
 */
com.ibm.mm.builder.utils.toolboxUtil.getWidgetDefinition = function(widgetDefId) {
    this.entries = this.entries || {};
    var entry = this.entries[widgetDefId];
    if (entry) { return entry; }
    var categoryModel = this.getCatalogModel();
    
    var rootNode = categoryModel.getRoot().start();
    var catIterator = categoryModel.getChildren(rootNode);
    
    while (catIterator.hasNext()) {
        var entryModel = categoryModel.getCatalogEntryModel(catIterator.next());
        var wdmd = entryModel.find(widgetDefId).start();
        if (wdmd) {
            this.setWidgetDefinition(wdmd);
            return wdmd;
        }
    }
};

com.ibm.mm.builder.utils.toolboxUtil.setWidgetDefinition = function(model) {
    this.entries = this.entries || {};
    this.entries[model.getID()] = model;
};

/**
 *
 * @param {boolean} reload, if true, empty the cached model.
 */
com.ibm.mm.builder.utils.toolboxUtil.getCatalogModel = function(reload) {
    if (reload || !this._catModel) {
        var enabler = com.ibm.mashups.enabler;
        var _catModel = enabler.model.Factory.getCatalogCategoryModel();
        _catModel.setStrategy(new enabler.strategy.ListLoadAheadStrategy(30));
        this._catModel = _catModel;
        this.catalogEntrys = null;
        this.entries = null;
    }
    return this._catModel;
};

com.ibm.mm.builder.utils.toolboxUtil.getDescription = function(catagory, id) {
    var _catModel = this.getCatalogModel();
    var _entryModel = _catModel.getCatalogEntryModel(catagory);
    var node = _entryModel.find(id).start();
    var desc = com.ibm.mm.builder.utils.enablerUtil.getNodeDescription(node);
    return com.ibm.mm.builder.utils.htmlUtil.escapeString(desc);
};

com.ibm.mm.builder.utils.toolboxUtil.getCategories = function(sync) {
    if (this.catalogEntrys) { return this.catalogEntrys; }
    var cm = this.getCatalogModel();
    var rootNode = cm.getRoot().start(sync);
    var iter = cm.getChildren(rootNode);
    this.catalogEntrys = [];
    while (iter.hasNext()) {
        this.catalogEntrys.push(iter.next());
    }
    return this.catalogEntrys;
};

com.ibm.mm.builder.utils.toolboxUtil.clearTooltipsTimer = function(/*Array*/tips) {
    for (var i = 0, l = tips.length; i < l; i++) {
        clearTimeout(tips.shift());
    }
};

com.ibm.mm.builder.utils.toolboxUtil.clearTooltips = function() {
    dojo.forEach(dojo.query(".dijitTooltip"), function(t) {
        t.style.display = "none";
    });
};

com.ibm.mm.builder.utils.toolboxUtil.preloadWidgetEntries = function() {
    var _catModel = this.getCatalogModel();
    var categories = this.getCategories(true);
    var mpFactory = com.ibm.mashups.enabler.io.XHRMultipartFactory;
    var mpHandler = mpFactory.create();
    mpHandler.startTransaction(mpFactory.CONTEXT_ENABLER);
    dojo.forEach(categories, function(catagory) {
        var _categoryModel = _catModel.getCatalogEntryModel(catagory);
        var elemIterator = _categoryModel.iterator();
        elemIterator.start(false);
    });
    mpHandler.endTransactionDeferred().start();
};

}
