if(!dojo._hasResource["com.ibm.mm.builder.widget.NvaMoveEffect"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.NvaMoveEffect"] = true;
dojo.provide("com.ibm.mm.builder.widget.NvaMoveEffect");

dojo.declare("com.ibm.mm.builder.widget.NvaMoveEffect", null, {
	snap: 20,
	time: 400,
	
	effectConstant: {HWCPane:{top:50,left:50,width:90,height:80}, 
					 HWCButton:{top:10,left:30,width:25,height:25}},
	
	callback: [],
	callbackArg: [],
	callbackContext: [],
	
	moverId:"",
	
	isNVAOpen: false,
	
	moveContainerDiv: null,
	
	constructor: function(params) {
		dojo.mixin(this, params);
		
		this.moveContainerDiv = document.createElement("div");
		dojo.style(this.moveContainerDiv, {
			position: "absolute",
			zIndex: "2000",
			backgroundColor: "azure"
		});
	},
	
	move: function(from, to) {
		document.body.appendChild(this.moveContainerDiv);
		dojo.marginBox(this.moveContainerDiv, {
			l: from.x,
			t: from.y,
			w: from.w,
			h: from.h
		});
		
		// get icon url and widget name
		var moverId = com.ibm.mm.builder.skinHelper.getWidgetIdByNvaSkinId(this.moverId);
		var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		var widgetTitle = widgetUtil.getWidgetInstanceTitle(moverId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		var widgetIcon = widgetUtil.getWidgetInstanceIcon(moverId);
		this.moveContainerDiv.innerHTML = dojo.string.substitute('<center><img src="${0}"/>${1}</center>', [widgetIcon, widgetTitle]);
		
		var times = this.time / this.snap;
		var topOffset = (to.y - from.y) / times;
		var leftOffset = (to.x - from.x) / times;
		var widthOffset = (to.w - from.w) / times;
		var heightOffset = (to.h - from.h) / times;
		this._startMove(topOffset, leftOffset, widthOffset, heightOffset, times);
	},
	
	_startMove: function(topOffset, leftOffset, widthOffset, heightOffset, times) {
		this.handle = setInterval(dojo.hitch(this, function() {
			var moveBox = dojo.marginBox(this.moveContainerDiv);
			moveBox.t += topOffset;
			moveBox.l += leftOffset;
			moveBox.w += widthOffset;
			moveBox.h += heightOffset;
			dojo.marginBox(this.moveContainerDiv, moveBox);
			
			if (--times <= 0) {
				document.body.removeChild(this.moveContainerDiv);
				while (this.callback.length) {
					var callback = this.callback.shift();
					var args = this.callbackArg.shift();
					var context = this.callbackContext.shift();
					if (args instanceof Array) {
						callback.apply(context, args);
					} else {
						callback.call(context, args);
					}
				}
				clearInterval(this.handle);
			}
		}), this.snap);
	},
	
    addCallback: function(callback, arg, context) {
		this.callback.push(callback);
		this.callbackArg.push(arg);
		this.callbackContext.push(context);
	},
	
	// another effect: nva skin font highlight
	highlightFont: function(params) {
		if (!params.div) { return; }
		
		var div = params.div;
		var repeat = 2 * (params.repeat || 1);
		var color = params.color || "blue";
		var time = params.time || 300;
		var oldColor = div.style.color || "black";
		
		this.handle = setInterval(function() {
			div.style.color = (div.style.color == color ? oldColor : color);
			if (--repeat <= 0) {
				clearInterval(this.handle);
			}
		}, time);
	}
});

}
