dojo.provide("com.ibm.pb.dnd.ControlledModeledSource");
dojo.require("com.ibm.dnd.ModeledSource");

dojo.declare("com.ibm.pb.dnd.ControlledModeledSource",
	com.ibm.dnd.ModeledSource,
	{
		constructor: function(/*DOMNode|String*/node, /*dojo.dnd.__SourceArgs?*/params) {
			this.inherited(arguments);
		},
		onDrop: function(source, nodes, copy) {
			this.inherited(arguments);
			
			// When enabler correctly updates the runtime nav model, 
			// DND can start to use transactions for page reordering
			//com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		},
		checkModelAcceptance: function(childItem,parentItem){
			if(typeof(ibmCfg.portalConfig) == "undefined") return true; // skip this for mashups
			var store = ibmCfg.controllers.navigation.getTreeModel(),
				isChildPrivate = this._isPrivate(childItem),
				isParentPrivate = this._isPrivate(parentItem),
				navBundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
				
			if(isChildPrivate && isParentPrivate) {
				// allowed: both the child and new parent are private
				return true;
			} else if(!isChildPrivate && isParentPrivate){
				// not allowed: cannot drag a public under a private page
				var statusMessage = new com.ibm.widgets.StatusMessage("error", navBundle["nav_invalid_drop_error"], dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["private_public_modelError"]);
				dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmStatusBox'}]);
				return false;
			} else {
				// new parent is public, permissions must be checked
				// TODO: Are there constants for the roles?
				var privAtParent = parentItem.hasRole("Privileged User");//store.getValue(parentItem,"accessLevel[Privileged User]$") == "Privileged User";
				var managerAtChild = parentItem.hasRole("Manager");//store.getValue(childItem,"accessLevel[Manager]$") == "Manager";
				var editorAtParent = parentItem.hasRole("Editor"); //store.getValue(parentItem,"accessLevel[Editor]$") == "Editor";
				
				if((isChildPrivate && !privAtParent) || (!isChildPrivate && (!managerAtChild || !editorAtParent))){
					// not allowed: must have priv user access on new parent when parent is public and child is private
					// not allowed: must have manager access on the child and editor access on new parent when both are public
					var statusMessage = new com.ibm.widgets.StatusMessage("error", navBundle["nav_invalid_drop_error"], nlsBundle = navBundle["nav_invalid_drop_msg"]);
					dojo.publish("/portal/status",[{message: statusMessage, uid: 'ibmStatusBox'}]);
					return false;
				} else return true;
			}
		},
		_isPrivate: function(navNode) {
			var isPrivate = false;
			if(navNode) {
				var xml = navNode.getXml(),
					expr = "./atom:content/*/ac:allowed-access[@ac:private='true']";
				isPrivate = com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, xml, {
					app: "http://www.w3.org/2007/app",
					atom: "http://www.w3.org/2005/Atom",
					ac: "http://www.ibm.com/xmlns/prod/lotus/access-control/v1.0"
				});
			}
			return isPrivate;
		}
	}
);
