/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.state.ShareableParameterSetAccessor");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.model.state.Accessor");
/**
 * Interface representing a ShareableParameterSetAccessor. 
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare( "com.ibm.mashups.enabler.model.state.ShareableParameterSetAccessor", [com.ibm.mashups.enabler.model.state.Accessor], {
	/**
     * Returns the id of ShareableParamterSet
     * @type String
     * @return {String}  name of ShareableParameterSet
     */
	getId:function() {
	},
    /**
     * Returns the scope of ShareableParamterSet or null, if this accessor represents the global scope.
     * @type String
     * @return {String}  name of the scope
     */
    getScope:function() {
    },
	/**
     * Returns an array of all Shareable Parameter names within this Shareable Parameter Set
     * @type String[]
     * @return {String[]}  array of all the ShareableParameterSet
     */
	getAllNames:function() {
	},
	/**
     * Set the value of a required item. It will replace the old value. If the value is a serialized version of complex data type, it's recommended for the widget to get the original 
     *  value, update the complex object and serialize again before calling this api.
     * @param {String} itemName The name of the required parameter 
     * @param {String} value The value of the required parameter
     * @type Boolean
     * @return {Boolean}  return true if item is updated or created successfully.
     */
	setItemValue:function(itemName,value){
	},
		/**
     * Confirm if it's possible to set the value of a required item. It will replace the old value. If the value is a serialized version of complex data type, it's recommended for the widget to get the original 
     *  value, update the complex object and serialize again before calling this api.
     * @param {String} itemName The name of the required parameter 
     * @param {String} value The value of the required parameter
     * @type Boolean
     * @return {Boolean}  return true if it's possible to set the value
     */
	confirmSetItemValue:function(itemName,value){
		return true;
	},
	/**
     * Remove the required item
     * @param {String} itemName The name of the required parameter that needs to be removed 
     * @type Boolean
     * @return {Boolean}  return true if item is removed successfully.
    */
	removeItem:function(itemName){
	},
	/**
     * confirm if it's possible to remove the required item
     * @param {String} itemName The name of the required parameter that needs to be removed 
     * @type Boolean
     * @return {Boolean}  return true if it's possible to remove item
    */
	confirmRemoveItem:function(itemName){
		return true;
	},
	/**
     * Returns the value of required item name
     * @param {String} itemName the name of the required parameter
     * @type String
     * @return {String} value of the required item
     */
	getItemValue:function(itemName) {
	},
	/**
     * Register listener so listener will be notified when an item set is updated
     * @param {Function}  listener which is a js function that's already scoped properly. 
     * @return{String} listener id 
     */
	registerListener:function(listener) {
	},
 /**
     * Remove the listener given a listener id
     * @param {String}  listenerId id of the listener that will be removed.  
     * @type Boolean
     * @return {Boolean} return true if listener is removed successfully  
     */
	removeListener:function(listenerId) {
	},
	/**
     * Confirm if it's possible to remove the listener given a listener id
     * @param {String}  listenerId id of the listener that will be removed.  
     * @type Boolean
     * @return {Boolean} return true if it's possible to remove Listener 
     */
	confirmRemoveListener:function(listenerId) {
		return true;
	}
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.model.state.ShareableParameterSetAccessorImpl");

