/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.persistence.PersistenceProvider");

dojo.declare("com.ibm.mashups.enabler.persistence.PersistenceProvider", null, {

    /**
     * Returns the selected objects.<br>
     *
     * @param {com.ibm.mashups.enabler.model.url.ModelUrl} url url that specifies the object(s) to find
     * @param {Object} selection selection criteria; for details on the selection object, refer
     * to the model specific documentation
     * @param {boolean} modifiable whether the returned data should be the representation of the modifiable node or not.
     * @param {Object} callback callback function, which is called with the following arguments:
     * <tt>function(result, status, parameters)</tt>, where<br>
     * <ul>
     * <li><tt>result</tt> is an array containing the selected objects; may contain zero or more objects</li>
     * <li><tt>status</tt> status code of the operation</li>
     * <li><tt>parameters</tt> are the parameters as passed into <tt>findBySelection</tt></li>
     * </ul>
     * @param {Object} parameters parameters to pass to the callback function; optional
     * @type void
     *
     * @ibm-spi
     */
    findBySelection: function(url, selection, callback, parameters, modifiable){
    },
    
    /**
     * TODO: see if this is the right signature
     * Removes the specified objects.
     *
     * @param {ModelURL} url the model URL that enables the connection to the backend.
     * @param {Object} callback callback function, which is called with the following arguments:
     * <tt>function(status, parameters)</tt>, where<br>
     * <ul>
     * <li><tt>status</tt> status code of the operation</li>
     * <li><tt>parameters</tt> are the parameters as passed into <tt>remove</tt></li>
     * </ul>
     * @param {Object} parameters parameters to pass to the callback function; optional
     * @type void
     *
     * @ibm-spi
     */
    remove: function(url, callback, parameters){
    },
    
    /**
     * TODO: redo the signature
     * Stores the specified objects.
     * @param {ModelURL} url the model URL that enables the connection to the backend.
     * @param {Object} object object to store.
     * @param {Object} callback callback function, which is called with the following arguments:
     * <tt>function(status, parameters)</tt>, where<br>
     * <ul>
     * <li><tt>status</tt> status code of the operation</li>
     * <li><tt>parameters</tt> are the parameters as passed into <tt>store</tt></li>
     * </ul>
     * @param {Object} parameters parameters to pass to the callback function; optional
     * @type void
     *
     * @ibm-spi
     */
    store: function(url, object, callback, parameters){
    }
});
