/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.IEventDescription");

//<INTERFACE>
/**
 * It contains various pieces of information describing an event.
 *
 * @ibm-api
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.IEventDescription", null, {


    constructor: function() {
        /**
         * @private
         */
    },
	/**
     The alias of the event.
     @type String
     */
    alias:/*String*/ "",
    /**
     The name of the event.
     @type String
     */
    name:/*String*/ "",
    /**
     The type of any payload. If this is set to null, no information is being provided.
     @type String
     */
    type:/*String*/ "",
    /**
     This provides the name of a callback function with the following signature and no return value.
     &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>   function(ievent) </code>
     @type String
     */
    handlingFn:/*String*/ "",
    /**
     it returns a user-oriented description (markup allowed) of the event in the requested locale. If no locale is supplied, the default locale of the iWidget is used (with "en" being the default iWidget locale). The description is likely to be displayed when a user is wiring event flow between iWidgets.
     @param{String} locale  required locale. Can be NULL. If no locale is supplied, the default locale of the iWidget is used (with "en" being the default iWidget locale).
     @type String
     @returns{String}  Return the description of a given locale,if no locale is provided, then the default locale of the iWidget is used.
     @deprecated please use getAttribute("description",locale) instead
     @since Deprecated since Version 2.0
     */
    getDescription: function(/*String*/locale) {
        return null;
    },
    /**
     This provides the default language of all the localized attributes within this event description.
     @type String
     */
    lang:/*String*/ "",
    /**
     This indicates if an event is a handled event or not. Default value is false.
     @type Boolean
     */
    isHandled: false,
    /**
     This indicates if an event is a published event or not. Default value is false.
     @type Boolean
     */
    isPublished: false,
    /**
     This method returns the asking value of an attribute of the event description. Each event description should have title and description . Normally title and description should be globalized, default locale should be specified by using the iso language code, if missing, the value for the default locale will be en. <br/>
     @param{String} attributeName  name of attribute. Can  Not be NULL.
     @param{String} locale  required locale. Can be NULL. If no locale is supplied, the default locale of the iWidget is used (with "en" being the default iWidget locale).
     @type String
     @returns{String}  Return the value of the required attribute,if locale is provided, it returns locale specific value.
     */
    getAttribute: function(/*String*/attributeName,/*String*/ locale) {
        return null;
    },
    /**
     The method set the value for a given event description attribute.It returns a handle of this eventdescription, return null upon failure. If the locale parameter is absent, then the given attribute won't be locale specific.
     @param{String} attributeName  name of attribute. Can  Not be NULL.
     @param{String} attributeValue  value of attribute. Can  Not be NULL.
     @param{String} locale  optional, locale. Can be NULL.
     @type com.ibm.mashups.iwidget.IEventDescription
     @returns{com.ibm.mashups.iwidget.IEventDescription}  return a handle of this eventdescription, return null upon failure..
     */
    setAttribute: function(/*String*/attributeName, /* String*/ attributeValue, /*String*/ locale) {
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.iwidget.IEventDescriptionImpl");
