# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# (C) Copyright IBM Corporation 2011. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT

import  java.lang.System  as  sys
lineSeparator = sys.getProperty('line.separator')

def uninstallBspaceOnServer (nodeName, serverName):
	print "start uninstall bspace on node: " + nodeName + " on server : " + serverName
	arr= '[-serverName "' + serverName + '" -nodeName "' + nodeName + '"]'
	try:
		AdminTask.uninstallBusinessSpace(arr)
	except:
		print "found error when uninstall bspace on node: " + nodeName + " on server : " + serverName
	
	print "finished uninstall bspace on node: " + nodeName + " on server : " + serverName
	return

def uninstallBspaceOnCluster (clusterName):
	print "start uninstall bspace on cluster: " + clusterName
	arr= '[-clusterName "' + clusterName + '"]'
	try:
		AdminTask.uninstallBusinessSpace(arr)
	except:
		print "found error when uninstall bspace on cluster: " + clusterName
		
	print "finished uninstall bspace on cluster: " + clusterName
	return

bspaceAppName="BSpaceEAR"

print lineSeparator
cells = AdminConfig.list('Cell').split(lineSeparator)
print cells
for cell in cells :
	cellName = AdminConfig.showAttribute(cell, 'name')
	#clusters = AdminClusterManagement.listClusters()
	clusters = AdminConfig.list('ServerCluster', cell).split(lineSeparator)
	#print "Number of clusters on DMGR is " + len(clusters)
	print clusters

	for cluster in clusters :
		if(cluster != ''):
			clusterName = AdminConfig.showAttribute(cluster, 'name')
			print " Found cluster: " + clusterName
			scopeAtt = 'WebSphere:cell=' + cellName + ',cluster=' + clusterName
			result = "false"
			applications = AdminApp.list(scopeAtt).split(lineSeparator)
			for application in applications:
				if (application.startswith(bspaceAppName) and result == "false"):
					result = "true"
					print "Found Bspace is configured on the cluster: " + clusterName
					
			if(result == "true"):
				uninstallBspaceOnCluster(clusterName)
	
	nodes = AdminConfig.list('Node', cell).split(lineSeparator)
	for node in nodes :
		if(node != ''):
			nodeName = AdminConfig.showAttribute(node, 'name')
			#servs = AdminControl.queryNames('type=Server,cell=' + cellName + ',node=' + nodeName + ',*').split(lineSeparator)
			servs = AdminServerManagement.listServers("APPLICATION_SERVER", nodeName)
			print "Number of running servers on node " + nodeName + ": %s \n" % (len(servs))
	
			for server in servs :
				serverName = AdminConfig.showAttribute(server, 'name')
				print " Found server: " + serverName + " on node: " + nodeName + " from cell: " + cellName
				scopeAtt = 'WebSphere:cell=' + cellName + ',node=' + nodeName + ',server=' + serverName
				result = "false"
				applications = AdminApp.list(scopeAtt).split(lineSeparator)
				for application in applications:
					if (application.startswith(bspaceAppName) and result == "false"):
						result = "true"
						print "Found Bspace is configured on the server: " + serverName
					
				if(result == "true"):
					uninstallBspaceOnServer(nodeName, serverName)



AdminConfig.save()
